Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/PermutationMemPRContext.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/PermutationMemPRContext.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/PermutationMemPRContext.cs	(revision 14450)
@@ -0,0 +1,80 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Algorithms.MemPR.Interfaces;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation {
+  [Item("MemPR Population Context (permutation)", "MemPR population context for permutation encoded problems.")]
+  [StorableClass]
+  public sealed class PermutationMemPRPopulationContext : MemPRPopulationContext<SingleObjectiveBasicProblem<PermutationEncoding>, Encodings.PermutationEncoding.Permutation, PermutationMemPRPopulationContext, PermutationMemPRSolutionContext> {
+
+    [StorableConstructor]
+    private PermutationMemPRPopulationContext(bool deserializing) : base(deserializing) { }
+    private PermutationMemPRPopulationContext(PermutationMemPRPopulationContext original, Cloner cloner)
+      : base(original, cloner) { }
+    public PermutationMemPRPopulationContext() : base("PermutationMemPRPopulationContext") { }
+    public PermutationMemPRPopulationContext(string name) : base(name) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationMemPRPopulationContext(this, cloner);
+    }
+
+    public override PermutationMemPRSolutionContext CreateSingleSolutionContext(ISingleObjectiveSolutionScope<Encodings.PermutationEncoding.Permutation> solution) {
+      return new PermutationMemPRSolutionContext(this, solution);
+    }
+  }
+
+  [Item("MemPR Solution Context (permutation)", "MemPR solution context for permutation encoded problems.")]
+  [StorableClass]
+  public sealed class PermutationMemPRSolutionContext : MemPRSolutionContext<SingleObjectiveBasicProblem<PermutationEncoding>, Encodings.PermutationEncoding.Permutation, PermutationMemPRPopulationContext, PermutationMemPRSolutionContext>, IPermutationSubspaceContext {
+
+    [Storable]
+    private IValueParameter<PermutationSolutionSubspace> subspace;
+    public PermutationSolutionSubspace Subspace {
+      get { return subspace.Value; }
+    }
+    ISolutionSubspace<Encodings.PermutationEncoding.Permutation> ISolutionSubspaceContext<Encodings.PermutationEncoding.Permutation>.Subspace {
+      get { return Subspace; }
+    }
+
+    [StorableConstructor]
+    private PermutationMemPRSolutionContext(bool deserializing) : base(deserializing) { }
+    private PermutationMemPRSolutionContext(PermutationMemPRSolutionContext original, Cloner cloner)
+      : base(original, cloner) {
+
+    }
+    public PermutationMemPRSolutionContext(PermutationMemPRPopulationContext baseContext, ISingleObjectiveSolutionScope<Encodings.PermutationEncoding.Permutation> solution)
+      : base(baseContext, solution) {
+
+      Parameters.Add(subspace = new ValueParameter<PermutationSolutionSubspace>("Subspace", new PermutationSolutionSubspace(null)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationMemPRSolutionContext(this, cloner);
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/PermutationSolutionSubspace.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/PermutationSolutionSubspace.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/PermutationSolutionSubspace.cs	(revision 14450)
@@ -0,0 +1,50 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Algorithms.MemPR.Interfaces;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation {
+  [Item("Solution subspace (Permutation)", "")]
+  [StorableClass]
+  public sealed class PermutationSolutionSubspace : Item, ISolutionSubspace<Encodings.PermutationEncoding.Permutation> {
+
+    [Storable]
+    private bool[,] subspace;
+    public bool[,] Subspace { get { return subspace; } }
+
+    [StorableConstructor]
+    private PermutationSolutionSubspace(bool deserializing) : base(deserializing) { }
+    private PermutationSolutionSubspace(PermutationSolutionSubspace original, Cloner cloner)
+      : base(original, cloner) {
+      subspace = (bool[,])original.subspace.Clone();
+    }
+    public PermutationSolutionSubspace(bool[,] subspace) {
+      this.subspace = subspace;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationSolutionSubspace(this, cloner);
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SimilarityCalculator.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SimilarityCalculator.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SimilarityCalculator.cs	(revision 14450)
@@ -0,0 +1,91 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation {
+  public static class PermutationSimilarityCalculator {
+
+    public static double CalculateSimilarity(Encodings.PermutationEncoding.Permutation left, Encodings.PermutationEncoding.Permutation right) {
+      if (left == null || right == null)
+        throw new ArgumentException("Cannot calculate similarity because one of the provided solutions or both are null.");
+      if (left.PermutationType != right.PermutationType)
+        throw new ArgumentException("Cannot calculate similarity because the provided solutions have different types.");
+      if (left.Length != right.Length)
+        throw new ArgumentException("Cannot calculate similarity because the provided solutions have different lengths.");
+      if (object.ReferenceEquals(left, right)) return 1.0;
+
+      switch (left.PermutationType) {
+        case PermutationTypes.Absolute:
+          return CalculateAbsolute(left, right);
+        case PermutationTypes.RelativeDirected:
+          return CalculateRelativeDirected(left, right);
+        case PermutationTypes.RelativeUndirected:
+          return CalculateRelativeUndirected(left, right);
+        default:
+          throw new InvalidOperationException("unknown permutation type");
+      }
+    }
+
+    private static double CalculateAbsolute(Encodings.PermutationEncoding.Permutation left, Encodings.PermutationEncoding.Permutation right) {
+      double similarity = 0.0;
+      for (int i = 0; i < left.Length; i++)
+        if (left[i] == right[i]) similarity++;
+
+      return similarity / left.Length;
+    }
+
+    private static double CalculateRelativeDirected(Encodings.PermutationEncoding.Permutation left, Encodings.PermutationEncoding.Permutation right) {
+      int[] edgesR = CalculateEdgesVector(right);
+      int[] edgesL = CalculateEdgesVector(left);
+
+      double similarity = 0.0;
+      for (int i = 0; i < left.Length; i++) {
+        if (edgesL[i] == edgesR[i]) similarity++;
+      }
+
+      return similarity / left.Length;
+    }
+
+    private static double CalculateRelativeUndirected(Encodings.PermutationEncoding.Permutation left, Encodings.PermutationEncoding.Permutation right) {
+      int[] edgesR = CalculateEdgesVector(right);
+      int[] edgesL = CalculateEdgesVector(left);
+
+      double similarity = 0.0;
+      for (int i = 0; i < left.Length; i++) {
+        if ((edgesL[i] == edgesR[i]) || (edgesL[edgesR[i]] == i))
+          similarity++;
+      }
+
+      return similarity / left.Length;
+    }
+
+    private static int[] CalculateEdgesVector(Encodings.PermutationEncoding.Permutation permutation) {
+      // transform path representation into adjacency representation
+      int[] edgesVector = new int[permutation.Length];
+      for (int i = 0; i < permutation.Length - 1; i++)
+        edgesVector[permutation[i]] = permutation[i + 1];
+      edgesVector[permutation[permutation.Length - 1]] = permutation[0];
+      return edgesVector;
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/StaticAPI/Trainer.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/StaticAPI/Trainer.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/StaticAPI/Trainer.cs	(revision 14450)
@@ -0,0 +1,47 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Algorithms.MemPR.Interfaces;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.SolutionModel.Univariate {
+  public static class Trainer {
+    public static ISolutionModel<Encodings.PermutationEncoding.Permutation> Train(IRandom random, IList<Encodings.PermutationEncoding.Permutation> pop, int N) {
+      ISolutionModel<Encodings.PermutationEncoding.Permutation> model;
+      switch (pop[0].PermutationType) {
+        case PermutationTypes.Absolute:
+          model = UnivariateAbsoluteModel.Create(random, pop, N);
+          break;
+        case PermutationTypes.RelativeDirected:
+          model = UnivariateRelativeModel.CreateDirected(random, pop, N);
+          break;
+        case PermutationTypes.RelativeUndirected:
+          model = UnivariateRelativeModel.CreateUndirected(random, pop, N);
+          break;
+        default: throw new ArgumentException(string.Format("unknown permutation type {0}", pop[0].PermutationType));
+      }
+      return model;
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/UnbiasedModelTrainer.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/UnbiasedModelTrainer.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/UnbiasedModelTrainer.cs	(revision 14450)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Algorithms.MemPR.Interfaces;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.SolutionModel.Univariate {
+  [Item("Unbiased Univariate Model Trainer (Permutation)", "", ExcludeGenericTypeInfo = true)]
+  [StorableClass]
+  public class UniasedModelTrainer<TContext> : NamedItem, ISolutionModelTrainer<TContext>
+    where TContext : IPopulationBasedHeuristicAlgorithmContext<SingleObjectiveBasicProblem<PermutationEncoding>, Encodings.PermutationEncoding.Permutation>,
+    ISolutionModelContext<Encodings.PermutationEncoding.Permutation> {
+    
+    [StorableConstructor]
+    protected UniasedModelTrainer(bool deserializing) : base(deserializing) { }
+    protected UniasedModelTrainer(UniasedModelTrainer<TContext> original, Cloner cloner) : base(original, cloner) { }
+    public UniasedModelTrainer() {
+      Name = ItemName;
+      Description = ItemDescription;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new UniasedModelTrainer<TContext>(this, cloner);
+    }
+
+    public void TrainModel(TContext context) {
+      context.Model = Trainer.Train(context.Random, context.Population.Select(x => x.Solution).ToList(), context.Problem.Encoding.Length);
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/UnivariateAbsoluteModel.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/UnivariateAbsoluteModel.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/UnivariateAbsoluteModel.cs	(revision 14450)
@@ -0,0 +1,97 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Algorithms.MemPR.Interfaces;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.SolutionModel.Univariate {
+  [Item("Univariate solution model (Permutation.Absolute)", "")]
+  [StorableClass]
+  public sealed class UnivariateAbsoluteModel : Item, ISolutionModel<Encodings.PermutationEncoding.Permutation> {
+    [Storable]
+    public IntMatrix Probabilities { get; set; }
+    [Storable]
+    public IRandom Random { get; set; }
+
+    [StorableConstructor]
+    private UnivariateAbsoluteModel(bool deserializing) : base(deserializing) { }
+    private UnivariateAbsoluteModel(UnivariateAbsoluteModel original, Cloner cloner)
+      : base(original, cloner) {
+      Probabilities = cloner.Clone(original.Probabilities);
+      Random = cloner.Clone(original.Random);
+    }
+    public UnivariateAbsoluteModel(IRandom random, int[,] probabilities) {
+      Probabilities = new IntMatrix(probabilities);
+      Random = random;
+    }
+    public UnivariateAbsoluteModel(IRandom random, IntMatrix probabilties) {
+      Probabilities = probabilties;
+      Random = random;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new UnivariateAbsoluteModel(this, cloner);
+    }
+
+    public Encodings.PermutationEncoding.Permutation Sample() {
+      var N = Probabilities.Rows;
+      var child = new Encodings.PermutationEncoding.Permutation(PermutationTypes.Absolute, N);
+      var indices = Enumerable.Range(0, N).Shuffle(Random).ToList();
+      var values = Enumerable.Range(0, N).Shuffle(Random).ToList();
+      for (var i = N - 1; i > 0; i--) {
+        var nextIndex = indices[i];
+        var total = 0.0;
+        for (var v = 0; v < values.Count; v++) {
+          total += Probabilities[nextIndex, values[v]] + 1.0 / N;
+        }
+        var ball = Random.NextDouble() * total;
+        for (var v = 0; v < values.Count; v++) {
+          ball -= Probabilities[nextIndex, values[v]] + 1.0 / N;
+          if (ball <= 0.0) {
+            child[nextIndex] = values[v];
+            values.RemoveAt(v);
+            indices.RemoveAt(i);
+            break;
+          }
+        }
+      }
+      child[indices[0]] = values[0];
+      return child;
+    }
+
+    public static UnivariateAbsoluteModel Create(IRandom random, IList<Encodings.PermutationEncoding.Permutation> pop, int N) {
+      var model = new int[N, N];
+      for (var i = 0; i < pop.Count; i++) {
+        for (var j = 0; j < N; j++) {
+          model[j, pop[i][j]]++;
+        }
+      }
+      return new UnivariateAbsoluteModel(random, model);
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/UnivariateRelativeModel.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/UnivariateRelativeModel.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Permutation/SolutionModel/Univariate/UnivariateRelativeModel.cs	(revision 14450)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Algorithms.MemPR.Interfaces;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Algorithms.MemPR.Permutation.SolutionModel.Univariate {
+  [Item("Univariate solution model (Permutation.Relative)", "")]
+  [StorableClass]
+  public sealed class UnivariateRelativeModel : Item, ISolutionModel<Encodings.PermutationEncoding.Permutation> {
+    [Storable]
+    public IntMatrix Probabilities { get; set; }
+
+    [Storable]
+    public IRandom Random { get; set; }
+
+    [Storable]
+    public PermutationTypes PermutationType { get; set; }
+
+    [StorableConstructor]
+    private UnivariateRelativeModel(bool deserializing) : base(deserializing) { }
+    private UnivariateRelativeModel(UnivariateRelativeModel original, Cloner cloner)
+      : base(original, cloner) {
+      Probabilities = cloner.Clone(original.Probabilities);
+      Random = cloner.Clone(original.Random);
+      PermutationType = original.PermutationType;
+    }
+    public UnivariateRelativeModel(IRandom random, int[,] probabilities, PermutationTypes permutationType) {
+      Probabilities = new IntMatrix(probabilities);
+      Random = random;
+      PermutationType = permutationType;
+    }
+    public UnivariateRelativeModel(IRandom random, IntMatrix probabilties, PermutationTypes permutationType) {
+      Probabilities = probabilties;
+      Random = random;
+      PermutationType = permutationType;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new UnivariateRelativeModel(this, cloner);
+    }
+
+    public Encodings.PermutationEncoding.Permutation Sample() {
+      var N = Probabilities.Rows;
+      var next = Random.Next(N);
+      var child = new Encodings.PermutationEncoding.Permutation(PermutationType, N);
+      child[0] = next;
+      var open = Enumerable.Range(0, N).Where(x => x != next).Shuffle(Random).ToList();
+      for (var i = 1; i < N - 1; i++) {
+        var total = 0.0;
+        for (var j = 0; j < open.Count; j++) {
+          total += Probabilities[next, open[j]] + 1.0 / N;
+        }
+        var ball = Random.NextDouble() * total;
+        for (var j = 0; j < open.Count; j++) {
+          ball -= Probabilities[next, open[j]] + 1.0 / N;
+          if (ball <= 0.0) {
+            child[i] = open[j];
+            next = open[j];
+            open.RemoveAt(j);
+            break;
+          }
+        }
+      }
+      child[N - 1] = open[0];
+      return child;
+    }
+
+    public static UnivariateRelativeModel CreateDirected(IRandom random, IList<Encodings.PermutationEncoding.Permutation> pop, int N) {
+      var model = new int[N, N];
+      for (var i = 0; i < pop.Count; i++) {
+        for (var j = 0; j < N - 1; j++) {
+          for (var k = j + 1; k < N; k++) {
+            model[pop[i][j], pop[i][k]]++;
+          }
+          model[pop[i][N - 1], pop[i][0]]++;
+        }
+      }
+      return new UnivariateRelativeModel(random, model, PermutationTypes.RelativeDirected);
+    }
+
+    public static UnivariateRelativeModel CreateUndirected(IRandom random, IList<Encodings.PermutationEncoding.Permutation> pop, int N) {
+      var model = new int[N, N];
+      for (var i = 0; i < pop.Count; i++) {
+        for (var j = 0; j < N - 1; j++) {
+          for (var k = j + 1; k < N; k++) {
+            model[pop[i][j], pop[i][k]]++;
+            model[pop[i][k], pop[i][j]]++;
+          }
+          model[pop[i][0], pop[i][N - 1]]++;
+          model[pop[i][N - 1], pop[i][0]]++;
+        }
+      }
+      return new UnivariateRelativeModel(random, model, PermutationTypes.RelativeUndirected);
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/SingleObjectiveSolutionScope.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/SingleObjectiveSolutionScope.cs	(revision 14449)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/SingleObjectiveSolutionScope.cs	(revision 14450)
@@ -21,4 +21,5 @@
 
 using System.Drawing;
+using HeuristicLab.Algorithms.MemPR.Interfaces;
 using HeuristicLab.Collections;
 using HeuristicLab.Common;
@@ -139,9 +140,4 @@
       Fitness = orphan.Fitness;
     }
-
-    public void Adopt(ISolutionScope<T> orphan) {
-      Solution = orphan.Solution;
-      Fitness = double.NaN;
-    }
   }
 }
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Util/EvaluationWrapper.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Util/EvaluationWrapper.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Util/EvaluationWrapper.cs	(revision 14450)
@@ -0,0 +1,50 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Algorithms.MemPR.Interfaces;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Algorithms.MemPR.Util {
+  public sealed class EvaluationWrapper<TSolution>
+      where TSolution : class, IItem {
+    private readonly ISingleObjectiveProblemDefinition problem;
+    private readonly ISingleObjectiveSolutionScope<TSolution> scope;
+    private readonly SingleEncodingIndividual individual;
+
+    public EvaluationWrapper(ISingleObjectiveProblemDefinition problem, ISingleObjectiveSolutionScope<TSolution> solution) {
+      this.problem = problem;
+      this.scope = (ISingleObjectiveSolutionScope<TSolution>)solution.Clone();
+      this.individual = new SingleEncodingIndividual(problem.Encoding, this.scope);
+    }
+
+    public double Evaluate(TSolution b) {
+      scope.Solution = b;
+      return problem.Evaluate(individual, null);
+    }
+
+    public double Evaluate(TSolution b, IRandom random) {
+      scope.Solution = b;
+      return problem.Evaluate(individual, random);
+    }
+  }
+}
Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Util/FitnessComparer.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Util/FitnessComparer.cs	(revision 14450)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/Util/FitnessComparer.cs	(revision 14450)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Algorithms.MemPR.Util {
+  public static class FitnessComparer {
+    public static bool IsBetter(bool maximization, double a, double b) {
+      return maximization && a > b
+             || !maximization && a < b;
+    }
+  }
+}
